/* 
    名稱: HiAir API client端範例程式
    撰寫者: HiNet - HiAir , mike huang
    日期: 2022/06/27
*/

// ===== 設定 API Endpoint =====
// 智慧簡訊
let url_sendSMS = 'https://api.sms.hinet.net/api/sendSMS/v1';
// 短簡訊
let url_sendShortSMS = 'https://api.sms.hinet.net/api/sendShortSMS/v1';
// 長簡訊
let url_sendLongSMS = 'https://api.sms.hinet.net/api/sendLongSMS/v1';
// 查詢簡訊
let url_querySMS = 'https://api.sms.hinet.net/api/querySMS/v1';
// 取消預約簡訊
let url_cancelSMS = 'https://api.sms.hinet.net/api/cancelSMS/v1';


// ===== 設定 請求欄位 =====
let data_base = {
    "username": "請填入帳號",
    "password": "請填入密碼",
};
// --- 發送簡訊 ---
// ex:
// {
// "username": "帳號",
// "password": "密碼",
// "mobile": "門號",
// "message": "簡訊內容",
// "limit_time": 1440,
// "order_time": "220201103000"
// }
let data_send_base = {
    ...data_base,
    "mobile": "請填入收訊手機號碼",
    "message": "請填入簡訊內容",
};
// 簡訊發送 - 一般
let data_send_type_01 = data_send_base;
// 簡訊發送 - 設定 limit_time
let data_send_type_02 = {
    ...data_send_base,
    "limit_time": 1440,  // 1~1440，單位：分鐘。 (有效範圍外之數值，將預設為 1440 分鐘)
};
// 簡訊發送 - 設定 order_time
let data_send_type_03 = {
    ...data_send_base,
    "order_time": "220627091500",  // 格式為 yyMMddHHmmss，yy：不含世紀之西元年，例如 2022 年請輸入 22。
};
// 簡訊發送 - 設定 limit_time, order_time
let data_send_type_04 = {
    ...data_send_base,
    "limit_time": 1440,
    "order_time": "220627091500",
};

// --- 查詢簡訊、取消預約簡訊 ---
// ex:
// {
// "username": "帳號",
// "password": "密碼",
// "message_id": "簡訊 ID",
// "msg_type": 2
// }
// 不指定簡訊類型
let data_query_cancel_type_01 = {
    ...data_base,
    "message_id": "請填入簡訊ID",  // ex: A8784619060309156XXX
};
// 指定簡訊類型
let data_query_cancel_type_02 = {
    ...data_base,
    "message_id": "請填入簡訊ID",  // ex: A8784619060309156XXX
    "msg_type": 2,  // 2:查詢/取消短簡訊 or 12:查詢/取消長簡訊
};


// ===== 指定 請求欄位 =====
// --- 發送簡訊 ---
let url = url_sendSMS;
// let url = url_sendShortSMS;
// let url = url_sendLongSMS;
let data = data_send_type_01;
// let data = data_send_type_02;
// let data = data_send_type_03;
// let data = data_send_type_04;

// --- 查詢簡訊、取消預約簡訊 ---
// let url = url_querySMS;
// let url = url_cancelSMS;
// let data = data_query_cancel_type_01;
// let data = data_query_cancel_type_02;


// ===== 發送請求 =====
// axios 設定timeout 60s
axios.defaults.timeout = 60000;

axios.post(url, data).then(function (response) {
    // http status code: 200類
    console.log("response.data:", response.data);
    // 發送簡訊 ex:
    // response.data: {ret_code: 0, ret_content: 'A8784619060309156XXX', msg_type: 2}
    // response.data: {ret_code: 0, ret_content: 'C1486512489694595XXX', msg_type: 12}
    // response.data: {ret_code: 0, ret_content: 'B7500564032930882XXX', msg_type: 2}

    // 查詢/取消簡訊 ex:
    // response.data: {ret_code: 0, ret_content: 'Successful:20220620092002', msg_type: 2}
    // response.data: {ret_code: 2, ret_content: 'DetailCode:[9] -> System contains no data', msg_type: 12}
    // response.data: {ret_code: 20, ret_content: 'reserve message, waiting send', msg_type: 2}
}).catch(function (error) {
    // http status code: 非200類
    console.log("==== axios error =====");
    console.log(error);
    if (error.response.request) {
    console.log(error.response.request.status);
    }
    if (error.response.data) {
    console.log(error.response.data);
    }
    // ex:
    // status: 401
    // data: {ret_code: 81, ret_content: 'Account or password error'}

    // status: 400
    // data: {ret_code: 92, ret_content: 'Json variable type error: limit_time'}

    // status: 400
    // {ret_code: 92, ret_content: 'Json variable type error: message_id'}

    // status: 400
    // data: {ret_code: 96, ret_content: 'msg_type value error, needs to be 2 or 12.'}
});
